<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="88px">
      <el-form-item label="升级计划" prop="upgradePlan">
        <el-input
          v-model="queryParams.upgradePlan"
          placeholder="请输入升级计划"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="升级时间" prop="upgradeTime">
        <el-date-picker clearable
          v-model="queryParams.upgradeTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择升级时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="是否已完成" prop="flag">
        <el-select v-model="queryParams.flag" placeholder="请选择是否已完成" clearable>
          <el-option
            v-for="dict in num_yes_no"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['mf:upgrade:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['mf:upgrade:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mf:upgrade:remove']"
        >删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['mf:upgrade:export']"
        >导出</el-button>
      </el-col> -->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="upgradeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" :label="$t('common.序号')" width="60" align="center" />
      <el-table-column label="升级计划" align="center" prop="upgradePlan" />
      <el-table-column label="升级时间" align="center" prop="upgradeTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.upgradeTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="是否已完成" align="center" prop="flag">
        <template #default="scope">
          <dict-tag :options="num_yes_no" :value="scope.row.flag"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['mf:upgrade:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['mf:upgrade:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备软硬件升级计划对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="upgradeRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="升级计划" prop="upgradePlan">
          <el-input v-model="form.upgradePlan" placeholder="请输入升级计划" />
        </el-form-item>
        <el-form-item label="升级时间" prop="upgradeTime">
          <el-date-picker clearable
            v-model="form.upgradeTime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择升级时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="是否已完成" prop="flag">
          <el-radio-group v-model="form.flag">
            <el-radio
              v-for="dict in num_yes_no"
              :key="dict.value"
              :label="parseInt(dict.value)"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Upgrade">
import { listUpgrade, getUpgrade, delUpgrade, addUpgrade, updateUpgrade } from "@/api/pms/upgrade";

const { proxy } = getCurrentInstance();
const { num_yes_no } = proxy.useDict('num_yes_no');

const upgradeList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    upgradePlan: null,
    upgradeTime: null,
    flag: null
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备软硬件升级计划列表 */
function getList() {
  loading.value = true;
  listUpgrade(queryParams.value).then(response => {
    upgradeList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    upgradePlan: null,
    upgradeTime: null,
    flag: 1
  };
  proxy.resetForm("upgradeRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备软硬件升级计划";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getUpgrade(_id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改设备软硬件升级计划";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["upgradeRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateUpgrade(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addUpgrade(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除设备软硬件升级计划编号为"' + _ids + '"的数据项？').then(function() {
    return delUpgrade(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('mf/upgrade/export', {
    ...queryParams.value
  }, `upgrade_${new Date().getTime()}.xlsx`)
}

getList();
</script>
